SystemOrganization addCategory: #AdministracionTPI!
SystemOrganization addCategory: #'AdministracionTPI-UI'!

WAComponent subclass: #BuscarAlumno
	instanceVariableNames: 'alumnoBuscado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministracionTPI-UI'!

!BuscarAlumno class methodsFor: 'class initialization' stamp: 'PabloAlegre 9/23/2012 14:41'!
canBeRoot 

	^true.! !

!BuscarAlumno class methodsFor: 'class initialization' stamp: 'PabloAlegre 9/23/2012 14:24'!
new

^super new alumnoBuscado: (Alumno new).! !

!BuscarAlumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 14:44'!
alumnoBuscado
	^ alumnoBuscado! !

!BuscarAlumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 14:44'!
alumnoBuscado: anObject
	alumnoBuscado := anObject! !

!BuscarAlumno methodsFor: 'initialization' stamp: 'PabloAlegre 9/23/2012 14:43'!
initialize 

	super initialize addDecoration: (GroupBoxDecoration new title: 'Buscar Alumno')! !

!BuscarAlumno methodsFor: 'rendering' stamp: 'PabloAlegre 9/23/2012 14:49'!
renderContentOn: html

| alumnos alumnosEncontrados |
alumnos := Set new.
alumnos add: (Alumno conMateriasCursadas).
alumnos add: (Alumno conNombre: 'Natalia' conApellido: 'Rodriguez' conDNI: '35321321' conDireccion: 'Quilmes' conEmail: 'nati@gmail.com' yLegajo: 20456).
alumnosEncontrados := Set new.

html text: 'Legajo: '. html textInput callback: [ : leg | (self alumnoBuscado legajo: leg) asNumber].
html break.
html submitButton callback: [alumnosEncontrados := alumnos select: [ : alumno | alumno legajo = alumnoBuscado legajo]]; with: 'Buscar'.
html break.

html table: [ 
		html tableRow: [ html tableHeading: 'Nombre y Apellido'.
						 html tableHeading: 'Legajo'.
		].
			
	alumnosEncontrados do: 
	[ : alumnoEncontrado | html tableRow: [ html tableData: [ alumnoEncontrado nombre, ' ', alumnoEncontrado apellido ].
							html tableData: [alumnoEncontrado legajo]
	]
			]
	]! !

WAComponent subclass: #EstadisticasAlumno
	instanceVariableNames: 'modelo carreraActual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministracionTPI-UI'!

!EstadisticasAlumno class methodsFor: 'class initialization' stamp: 'PabloAlegre 9/20/2012 20:10'!
canBeRoot 
^true.! !

!EstadisticasAlumno class methodsFor: 'class initialization' stamp: 'PabloAlegre 9/23/2012 14:05'!
new

^super new modelo: (Alumno conMateriasCursadas); carreraActual: 'TPI'.! !

!EstadisticasAlumno methodsFor: 'accessing' stamp: 'NataliaRodriguez 9/16/2012 18:15'!
carreraActual
	^ carreraActual! !

!EstadisticasAlumno methodsFor: 'accessing' stamp: 'NataliaRodriguez 9/16/2012 18:15'!
carreraActual: anObject
	carreraActual := anObject! !

!EstadisticasAlumno methodsFor: 'initialization' stamp: 'PabloAlegre 9/23/2012 14:12'!
initialize
	super initialize.
	self addDecoration: (GroupBoxDecoration  new title: 'Estadisticas de Alumno')! !

!EstadisticasAlumno methodsFor: 'accessing' stamp: 'NataliaRodriguez 9/16/2012 17:19'!
modelo
	^ modelo! !

!EstadisticasAlumno methodsFor: 'accessing' stamp: 'NataliaRodriguez 9/16/2012 17:19'!
modelo: anObject
	modelo := anObject! !

!EstadisticasAlumno methodsFor: 'rendering' stamp: 'NatiRodriguez 9/21/2012 17:45'!
renderContentOn: html

html form: [
	self renderDatosAlumno: html.
	self renderEstadoAlumno: html.
].! !

!EstadisticasAlumno methodsFor: 'rendering' stamp: 'NatiRodriguez 9/21/2012 17:43'!
renderDatosAlumno: html

	html text: 'Alumno: ', modelo nombre, ' ', modelo apellido. 
	html break.
	html text: 'Legajo ', (modelo legajo asString). 
	html break. html break.! !

!EstadisticasAlumno methodsFor: 'rendering' stamp: 'PabloAlegre 9/23/2012 14:05'!
renderEstadoAlumno: html

	html text: 'Carrera: '.
	(html select)
			list: #('TPI' 'LDS');
			callback: [:seleccionada | self carreraActual: seleccionada.].
	html break. html break.
	html text: 'Estado: Activo' ", modelo estadoEn: carreraActual". 
	html break.
	html text: 'Materias Aprobadas: ', ((modelo materiasAprobadas: (self carreraActual)) asString), ' de 23' ",self carreraActual materias size". 
	html break.
	html text: 'Materias Recursadas: ', ((modelo materiasRecursadas: (self carreraActual)) asString). 
	html break.
	html text: 'Materias Actuales: ', ((modelo materiasActuales: (self carreraActual)) asString). 
	html break.
	html text: 'Auxiliar: ', modelo esAuxiliar asString. 
	html break.
	html text: 'Promedio: ', modelo promedioActual asString.
	html break.! !

!EstadisticasAlumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/22/2012 12:15'!
style

^'body{border-style:ridge;padding: 5px}'! !

WAWindowDecoration subclass: #GroupBoxDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministracionTPI-UI'!

!GroupBoxDecoration methodsFor: 'rendering' stamp: 'NatiRodriguez 9/22/2012 14:57'!
renderCloseButtonOn: html! !

!GroupBoxDecoration methodsFor: 'rendering' stamp: 'NatiRodriguez 9/22/2012 13:37'!
style

^ '.window-titlebar {background-color: #aaaaaa; padding: 5px; margin-bottom: 5px}
	    .window-close {float: right}
	   .window-title {}
	    .window-content {clear: both}
	'! !

Object subclass: #Alumno
	instanceVariableNames: 'nombre apellido dni direccion telefono legajo email esAuxiliar cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministracionTPI'!

!Alumno class methodsFor: 'class initialization' stamp: 'PabloAlegre 9/23/2012 12:19'!
conMateriasCursadas
 | alumno |
 alumno:= super new nombre: 'Pablo'; apellido: 'Alegre'; dni: 35123123; direccion: 'Florencio Varela'; email: 'pablo@gmail.com'; legajo: 20123; esAuxiliar: false; cursos: Dictionary new.
 alumno agregarCurso: (Comision new carrera: 'TPI').
 alumno agregarCurso: (Comision new carrera: 'TPI').
 alumno agregarCurso: (Comision new carrera: 'TPI').
 alumno agregarCurso: (Comision new carrera: 'TPI').
 ^alumno.! !

!Alumno class methodsFor: 'class initialization' stamp: 'PabloAlegre 9/23/2012 11:15'!
conNombre: unNombre conApellido: unApellido conDNI: unDNI conDireccion: unaDireccion conEmail: unEmail yLegajo: unLegajo
 ^super new nombre: unNombre; apellido: unApellido; dni: unDNI; direccion: unaDireccion; email: unEmail; legajo: unLegajo; esAuxiliar: false; cursos: Dictionary new.


! !

!Alumno methodsFor: 'cursos' stamp: 'PabloAlegre 9/23/2012 12:04'!
agregarCurso: unaComision

	self cursos at: unaComision put: 'En curso'.! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/14/2012 18:29'!
apellido
	^ apellido! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/14/2012 18:29'!
apellido: anObject
	apellido := anObject! !

!Alumno methodsFor: 'estadisticas' stamp: 'PabloAlegre 9/23/2012 12:15'!
cantidadDeMateriasEn: unaCarrera conEstado: unEstado
 
	| cantidadDeMaterias |
	cantidadDeMaterias := 0.	
	self cursos associationsDo: [ : cursoEntry | ((cursoEntry key carrera = unaCarrera) and: (cursoEntry value = unEstado)) ifTrue: [cantidadDeMaterias := cantidadDeMaterias + 1]].
	^cantidadDeMaterias.! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 10:52'!
cursos
	^ cursos! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 10:52'!
cursos: anObject
	cursos := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/14/2012 18:29'!
direccion
	^ direccion! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/14/2012 18:29'!
direccion: anObject
	direccion := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/14/2012 18:29'!
dni
	^ dni! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/14/2012 18:29'!
dni: anObject
	dni := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/14/2012 18:29'!
email
	^ email! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/14/2012 18:29'!
email: anObject
	email := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'NataliaRodriguez 9/16/2012 18:02'!
esAuxiliar
	^ esAuxiliar! !

!Alumno methodsFor: 'accessing' stamp: 'NataliaRodriguez 9/16/2012 18:02'!
esAuxiliar: anObject
	esAuxiliar := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/14/2012 18:29'!
legajo
	^ legajo! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/14/2012 18:29'!
legajo: anObject
	legajo := anObject! !

!Alumno methodsFor: 'estadisticas' stamp: 'PabloAlegre 9/23/2012 11:35'!
materiasActuales: unaCarrera
 
	^self cantidadDeMateriasEn: unaCarrera conEstado: 'En curso'! !

!Alumno methodsFor: 'estadisticas' stamp: 'PabloAlegre 9/23/2012 11:35'!
materiasAprobadas: unaCarrera
 
	^self cantidadDeMateriasEn: unaCarrera conEstado: 'Aprobado'! !

!Alumno methodsFor: 'estadisticas' stamp: 'PabloAlegre 9/23/2012 11:36'!
materiasRecursadas: unaCarrera
 
	 ^self cantidadDeMateriasEn: unaCarrera conEstado: 'Recursado'! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/14/2012 18:29'!
nombre
	^ nombre! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/14/2012 18:29'!
nombre: anObject
	nombre := anObject! !

!Alumno methodsFor: 'estadisticas' stamp: 'NataliaRodriguez 9/16/2012 18:09'!
promedioActual
 ^0 "POR EL MOMENTO. TODO"! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/14/2012 18:29'!
telefono
	^ telefono! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 9/14/2012 18:29'!
telefono: anObject
	telefono := anObject! !

Object subclass: #Carrera
	instanceVariableNames: 'nombre materias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministracionTPI'!

!Carrera class methodsFor: 'class initialization' stamp: 'NataliaRodriguez 9/16/2012 18:21'!
llamada: unNombre

^super new nombre: unNombre; materias: OrderedCollection new.! !

!Carrera methodsFor: 'accessing' stamp: 'NataliaRodriguez 9/16/2012 18:18'!
materias
	^ materias! !

!Carrera methodsFor: 'accessing' stamp: 'NataliaRodriguez 9/16/2012 18:18'!
materias: anObject
	materias := anObject! !

!Carrera methodsFor: 'accessing' stamp: 'NataliaRodriguez 9/16/2012 18:18'!
nombre
	^ nombre! !

!Carrera methodsFor: 'accessing' stamp: 'NataliaRodriguez 9/16/2012 18:18'!
nombre: anObject
	nombre := anObject! !

Object subclass: #Comision
	instanceVariableNames: 'numero cuatrimestre materia carrera horarios docenteReal docenteRegistrado alumnosInscriptos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministracionTPI'!

!Comision class methodsFor: 'as yet unclassified' stamp: 'PabloAlegre 9/23/2012 12:01'!
numero: numeroDeComision delCuatrimestre: anioYNumeroDeCuatrimestre deLaMateria: unaMateria deLaCarrera: unaCarrera

super new numero: numeroDeComision; cuatrimestre: anioYNumeroDeCuatrimestre; materia: unaMateria carrera: unaCarrera.! !

!Comision methodsFor: 'alumnos' stamp: 'PabloAlegre 9/23/2012 11:04'!
agregarAlumno: unAlumno

	self alumnosInscriptos add: unAlumno.! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 11:03'!
alumnosInscriptos
	^ alumnosInscriptos! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 11:03'!
alumnosInscriptos: anObject
	alumnosInscriptos := anObject! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 11:02'!
carrera
	^ carrera! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 11:02'!
carrera: anObject
	carrera := anObject! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 11:56'!
cuatrimestre
	^ cuatrimestre! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 11:56'!
cuatrimestre: anObject
	cuatrimestre := anObject! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 11:02'!
docenteReal
	^ docenteReal! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 11:02'!
docenteReal: anObject
	docenteReal := anObject! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 11:02'!
docenteRegistrado
	^ docenteRegistrado! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 11:02'!
docenteRegistrado: anObject
	docenteRegistrado := anObject! !

!Comision methodsFor: 'alumnos' stamp: 'PabloAlegre 9/23/2012 11:05'!
eliminarAlumno: unAlumno

	self alumnosInscriptos remove: unAlumno.! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 11:02'!
horarios
	^ horarios! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 11:02'!
horarios: anObject
	horarios := anObject! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 11:02'!
materia
	^ materia! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 11:02'!
materia: anObject
	materia := anObject! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 11:56'!
numero
	^ numero! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 11:56'!
numero: anObject
	numero := anObject! !

Object subclass: #Materia
	instanceVariableNames: 'nombre carrera comisiones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministracionTPI'!

!Materia methodsFor: 'comisiones' stamp: 'PabloAlegre 9/23/2012 11:05'!
agregarComision: unaComision

	self comisiones add: unaComision.! !

!Materia methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 10:56'!
carrera
	^ carrera! !

!Materia methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 10:56'!
carrera: anObject
	carrera := anObject! !

!Materia methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 10:56'!
comisiones
	^ comisiones! !

!Materia methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 10:56'!
comisiones: anObject
	comisiones := anObject! !

!Materia methodsFor: 'comisiones' stamp: 'PabloAlegre 9/23/2012 11:06'!
eliminarComision: unaComision

	self comisiones remove: unaComision.! !

!Materia methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 10:56'!
nombre
	^ nombre! !

!Materia methodsFor: 'accessing' stamp: 'PabloAlegre 9/23/2012 10:56'!
nombre: anObject
	nombre := anObject! !
